$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! COMPILE.COM:
$!
$! This script is an intelligent compile script that only compiles 
$! files that are "out-of-date" with respect to the corresponding 
$! object file. 
$!
$! Author: Mumit Khan
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say 	:= write sys$output
$
$!
$! Define the compilation flags. Defining these flags here would let you
$! compile an entire distribution with the same flags.
$!
$
$ defines 	:=
$ ccompile 	:= cc'defines'/undefine=(ANSI_LIB)/debug/nooptimize
$ fcompile 	:= fortran'defines'/debug/nooptimize
$ mcompile 	:= macro'defines'
$
$!
$! Must supply a file name to compile!
$!
$
$ if p1 .eqs. ""
$ then
$	say "COMPILE: Must supply a file name to compile"
$	goto CLEANUP
$ endif
$
$ upline = f$edit (p1, "UPCASE")
$ line_len = f$length(p1)
$
$ compile = fcompile
$ line = f$extract (0, f$locate(".",p1),p1)
$
$!
$! determine the type of program (defaults to FORTRAN).
$! 
$
$ if f$locate(".FOR", upline) .ne. line_len .or. -
    f$locate(".FTN", upline) .ne. line_len
$ then
$ 	file_type = "FORTRAN"
$ 	p1s = upline
$ 	goto DO_FILE
$ endif
$
$ if f$locate(".C", upline) .ne. line_len
$ then
$ 	file_type = "C"
$ 	p1s = upline
$ 	compile = ccompile
$ 	goto DO_FILE
$ endif
$
$ if f$locate(".MAR", upline) .ne. line_len
$ then
$ 	file_type = "MACRO"
$ 	p1s = upline
$ 	compile = mcompile
$ 	goto DO_FILE
$ endif
$
$ if f$locate(".", line) .eq. line_len
$ then
$ 	file_type = "FORTRAN"
$ 	p1s = upline + ".FOR"
$ 	goto DO_FILE
$ endif
$
$ say "Error in file type -- ''line'"
$ EXIT
$
$ DO_FILE:
$ p1o = line + ".OBJ"
$
$ if f$search(p1s) .eqs. ""
$ then
$ 	say p1s + " not found!"
$ 	goto CLEANUP
$ endif
$ if f$search(p1o) .eqs. "" then goto Recompile
$
$!
$! Check the dates of the .FOR and .OBJ files.
$!
$
$ srcdate = f$file_attributes(p1s,"RDT")
$ objdate = f$file_attributes(p1o,"RDT")
$ bin_srcdate = f$cvtime(srcdate)
$ bin_objdate = f$cvtime(objdate)
$
$ if bin_srcdate .les. bin_objdate
$ then
$ 	write sys$output "Up-to-date... " + p1s
$ 	goto CLEANUP
$ endif
$
$ Recompile:
$ write sys$output "Compiling... " + p1s
$ gosub COMPILE_MODULE
$
$
$ COMPILE_MODULE:
$
$ compile 'line' 
$ return
$
$ CLEANUP:
$ EXIT
