C +++
C
C Source: src/source/bm/sradpol.F
C
C ----------------------------------------------
C                SHADOW
C      Center for X-ray Lithography
C     University of Wisconsin-Madison
C  3731 Schneider Dr., Stoughton, WI, 53589
C ----------------------------------------------
C 
C Log:	sradpol.F
C Revision 1.2  90/07/18  19:38:09  khan
C Unixified the programs by removing non standard features, most notably
C DEC's DO .. END DO strucutures.
C 
C Revision 1.1  90/07/11  10:45:03  khan
C Initial revision
C 
C 
C ---

C**************************************************************
C	THIS PROGRAM COMPUTE THE FLUX DISTRIBUTION VS. ELEVATION
C	ANGLE PSI.BANDPASS IS 1 EV.
C	Units = photons/sec/Vertical rad/eV at 1mA for the horizontal
C	        acceptance specified.
	PROGRAM	SRADPOL
	IMPLICIT REAL*8 (A-H,O-Z)
C
	INCLUDE	'bm.blk'
C
1	CALL INPUT
	CALL SETUP
	CALL COMPUTE
	CALL FILESAVE
	WRITE (6,100)
100	FORMAT(1X,'DONE. ANOTHER RUN (Y/N) ?',$)
	READ (5,110) Q
110	FORMAT(A8)
	IF (Q.EQ.'Y') GO TO 1
	STOP 'SEE YOU LATER !'
	END
C*************************************************************
	SUBROUTINE INPUT
	IMPLICIT REAL*8 (A-H,O-Z)
C
	INCLUDE	'bm.blk'
C
	BENER	= RNUMBER ('Beam Energy [ GeV ] ? ')
     	PHOT	= RNUMBER ('Photon energy [ eV ] ? ')
     	THETA 	= RNUMBER ('Horizonatal acceptance [ mrad ] ? ')
     	PSIMAX	= RNUMBER ('Maximum vertical elevation [ mrad ] ? ')
     	NP	= IRINT ('Number of points [ odd ] ? ')
	RETURN
	END
C*****************************************************************
