
C+++
C
C       Subroutine getparams,gets all of the parameters either from a gfile
C
C
C
C
C       or from command line parameters
C
C---
	subroutine GetParams( infile, outfile, seed,
     $                        exposure, liformat, loformat, 
     $                        optimize, thick, gfilename,
     $                        length)
	character*(*) infile, outfile 
	character*80 arg
	character*(*) gfilename
	integer iargc
	integer iformat
	logical optimize
	integer icnt, inum, seed
	real exposure
	real thick
	real length
	logical liformat, lliformat, loformat, lloformat
	logical lgfile, lseed,  linfile, loutfile, lexposure
	logical loptimize
	logical lthick
	logical llength
	double precision dexposure
	double precision dthick
	double precision dlength
	integer opt

        lgfile = .false.
	lseed = .false.
	linfile = .false.
	loutfile = .false.
	lexposure = .false.
	lloformat = .false.
	lliformat = .false.
	loptimize = .false.
	optimize = .false.
	lthick = .false.
	llength = .false.



        inum = iargc()
	if ( inum .eq. 0) goto 200
	icnt = 0
100     continue
        icnt = icnt + 1
	call getarg(icnt, arg)
	if ( arg(1:3) .eq. '-t ') then
	     lthick = .true.
	     icnt = icnt + 1
	     call getarg(icnt,arg)
             read(arg,*) thick
	else if (arg(1:3) .eq. '-le' ) then
	     llength = .true.
	     icnt = icnt + 1
	     call getarg(icnt,arg)
	     read(arg,*) length
	else if ( arg(1:3) .eq. '-g ') then
	     lgfile = .true.
	     icnt = icnt + 1
	     call getarg( icnt, arg )
	     call strcopy(arg,gfilename)
        else if (arg(1:3) .eq. '-i ') then
	     linfile = .true.
	     icnt = icnt + 1
	     call getarg(icnt, arg )
	     call strcopy(arg,infile)
	else if (arg(1:3) .eq. '-o ' ) then
	     loutfile = .true.
	     icnt = icnt + 1
	     call getarg(icnt, arg)
	     call strcopy(arg,outfile)
	else if (arg(1:3) .eq. '-s ') then 
	     lseed = .true.
	     icnt = icnt + 1
	     call getarg(icnt,arg)
	     read (arg,*) seed
	else if (arg(1:3) .eq. '-e ') then
	     lexposure = .true.
	     icnt = icnt + 1
	     call getarg(icnt, arg )
	     read(arg,*) exposure
	else if (arg(1:3) .eq. '-fi') then
	     lliformat = .true.
	     liformat = .true.
	else if (arg(1:3) .eq. '-ui') then
	     lliformat = .true.
	     liformat = .false.
	else if (arg(1:3) .eq. '-fo') then
	     lloformat = .true.
	     loformat = .true.
	else if (arg(1:3) .eq. '-uo') then 
	     lloformat = .true.
	     loformat = .false.
	else if (arg(1:3) .eq. '-op') then
	     loptimize = .true.
	     optimize = .true.
	else if (arg(1:3) .eq. '-np') then
	     loptimize = .true.
	     optimize = .false.
	else
	     call usage()
	     stop
	endif
        if ( icnt .lt. inum) goto 100 
200     if (lgfile .eq. .false.) gfilename = 'spg.g'
	call gfile(gfilename)
	if (lthick .eq. .false.) then
	    call gnumber('sys_thickness','Entry: Enter resist'
     $       //' thickness: ',dthick)
	    thick = real(dthick)
	endif
	if (llength .eq. .false.) then
	    call gnumber('sys_length','entry: enter resist length:'
     $           ,dlength)
	    length = real(dlength)
	endif
	if (loptimize .eq. .false.) then
	    call gint('en_optimize','entry: Prepare data for'
     $       //' optimization: (1=y,0=n) ', opt)
		if(opt .eq. 1) then
		    optimize = .true.
		else
		    optimize = .false.
		endif
	endif
	if (linfile .eq. .false.) 
     $      call gstring('en_infile','entry: Enter file containing'
     $            //' aerial image: ',  infile)
	if (lseed .eq. .false. )
     $      call gint('en_seed','SPG: Enter random number seed: ',
     $                    seed)
	if (lexposure .eq. .false. ) then
           call gnumber('en_exp','entry: Enter exposure time: ',
     $                    dexposure)
	   exposure = real ( dexposure)
	endif
	if (loutfile .eq. .false.)
     $      call gstring('en_outfile','entry: Enter name of'
     $      // 'output file: ', outfile)
	if (lloformat .eq. .false.) then
	    call gint('en_outformat','entry: formatted output?'
     $      //'(1=y,0=n): ',iformat)
	    if (iformat .eq. 1) then 
		 loformat = .true.
	    else
		 loformat = .false.
	    endif 
	endif
	if (lliformat .eq. .false.) then
	     call gint('en_informat','spg: formatted input?'
     $       //'(1=y,0=n): ',iformat)
	     if (iformat .eq. 1) then
		  liformat = .true.
	     else
		  liformat = .false.
	     endif
	endif
	call gclose()
	return
	end

