/*
 * 
 * Author: Mumit Khan <khan@xraylith.wisc.edu>
 *
 * Source: src/utils/special/chparm.h
 *
 */

#ifndef chval_h
#define chval_h


typedef struct NmlDataRec NmlDataRec, *NmlData;
typedef struct NmlListRec NmlListRec, *NmlList;

typedef enum {
    DT_none = -1,
    DT_int, 
    DT_flt, 
    DT_dbl, 
    DT_str,
    DT_num
} DataType;


typedef enum {
    NML_none = -1,
    NML_source,
    NML_oe,
    NML_num
} NmlType;

struct NmlListRec {
    NmlType	nml_type;
    int		size;			/* all the elements */
    NmlDataRec	*nml_data;
};

struct NmlDataRec {
    char 	*synopsis;
    char	allow_change;
    char 	*name;
    DataType	data_type;
    char 	*value;
};


extern NmlData get_nml_record ();
extern int print_values ();
extern int print_val ();

#endif /*chval_h*/
